﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Text;
using System.IO.IsolatedStorage;
using System.Windows.Resources;
using System.IO;

namespace WebBrowserImageSample
{
	public partial class MainPage : PhoneApplicationPage
	{
		// Constructor
		public MainPage()
		{
			InitializeComponent();

			SaveFilesToIsoStore();

			MyWebBrowser.Navigate(new Uri("readme.htm", UriKind.Relative));
		}

		private void SaveFilesToIsoStore()
		{
			//These files must match what is included in the application package,
			//or BinaryStream.Dispose below will throw an exception.
			string[] files = {
            "readme.htm", "desert.jpg"
        };

			IsolatedStorageFile isoStore = IsolatedStorageFile.GetUserStoreForApplication();

			if (false == isoStore.FileExists(files[0]))
			{
				foreach (string f in files)
				{
					StreamResourceInfo sr = Application.GetResourceStream(new Uri(f, UriKind.Relative));
					using (BinaryReader br = new BinaryReader(sr.Stream))
					{
						byte[] data = br.ReadBytes((int)sr.Stream.Length);
						SaveToIsoStore(f, data);
					}
				}
			}
		}

		private void SaveToIsoStore(string fileName, byte[] data)
		{
			string strBaseDir = string.Empty;
			string delimStr = "/";
			char[] delimiter = delimStr.ToCharArray();
			string[] dirsPath = fileName.Split(delimiter);

			//Get the IsoStore.
			IsolatedStorageFile isoStore = IsolatedStorageFile.GetUserStoreForApplication();

			//Re-create the directory structure.
			for (int i = 0; i < dirsPath.Length - 1; i++)
			{
				strBaseDir = System.IO.Path.Combine(strBaseDir, dirsPath[i]);
				isoStore.CreateDirectory(strBaseDir);
			}

			//Remove the existing file.
			if (isoStore.FileExists(fileName))
			{
				isoStore.DeleteFile(fileName);
			}

			//Write the file.
			using (BinaryWriter bw = new BinaryWriter(isoStore.CreateFile(fileName)))
			{
				bw.Write(data);
				bw.Close();
			}
		}

	}
}